config/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('mailing.urls', namespace='mailing')),
]

mailing/urls.py
from django.urls import path

from mailing.apps import MailingConfig
from mailing.views import MailingListView, MailingSettingsCreateView, MailingSettingsUpdateView, ClientListView, \
    ClientCreateView, ClientUpdateView, ClientDeleteView, MailingSettingsDeleteView, MailingClientsListView, \
    toggle_client, MessageListView, MessageDeleteView, MessageUpdateView, MessageCreateView

app_name = MailingConfig.name


urlpatterns = [
    path('', MailingListView.as_view(), name='mailing_list'),
    path('create/', MailingSettingsCreateView.as_view(), name='mailing_create'),
    path('update/<int:pk>/', MailingSettingsUpdateView.as_view(), name='mailing_update'),
    path('delete/<int:pk>/', MailingSettingsDeleteView.as_view(), name='mailing_delete'),

    path('<int:pk>/clients/', MailingClientsListView.as_view(), name='mailing_clients'),
    path('<int:pk>/clients/add/<int:client_pk>/', toggle_client, name='mailing_clients_toggle'),

    path('clients/', ClientListView.as_view(), name='clients'),
    path('clients/create/', ClientCreateView.as_view(), name='clients_create'),
    path('clients/update/<int:pk>/', ClientUpdateView.as_view(), name='clients_update'),
    path('clients/delete/<int:pk>/', ClientDeleteView.as_view(), name='clients_delete'),

    path('messages/', MessageListView.as_view(), name='messages'),
    path('messages/create/', MessageCreateView.as_view(), name='messages_create'),
    path('messages/update/<int:pk>/', MessageUpdateView.as_view(), name='messages_update'),
    path('messages/delete/<int:pk>/', MessageDeleteView.as_view(), name='messages_delete'),
]

mailing/models.py
from django.db import models


NULLABLE = {'blank': True, 'null': True}


class Client(models.Model):
    email = models.EmailField(verbose_name='Почта для рассылки')
    first_name = models.CharField(**NULLABLE, verbose_name='Имя', max_length=150)
    last_name = models.CharField(**NULLABLE, verbose_name='Фамилия', max_length=150)
    comment = models.TextField(**NULLABLE, verbose_name='Комментарий')

    def __str__(self):
        return f'{self.first_name} {self.last_name} ({self.email})'

    class Meta:
        verbose_name = 'Клиент'
        verbose_name_plural = 'Клиенты'


class MailingSettings(models.Model):

    PERIOD_DAILY = 'daily'
    PERIOD_WEEKLY = 'weekly'
    PERIOD_MONTHLY = 'monthly'

    PERIODS = (
        (PERIOD_DAILY, 'Ежедневная'),
        (PERIOD_WEEKLY, 'Раз в неделю'),
        (PERIOD_MONTHLY, 'Раз в месяц'),
    )

    STATUS_CREATED = 'created'
    STATUS_STARTED = 'started'
    STATUS_DONE = 'done'
    STATUSES = (
        (STATUS_STARTED, 'Запущена'),
        (STATUS_CREATED, 'Создана'),
        (STATUS_DONE, 'Завершена'),
    )

    time = models.TimeField(verbose_name='Время')
    period = models.CharField(max_length=20, choices=PERIODS, default=PERIOD_DAILY, verbose_name='Период')
    status = models.CharField(max_length=20, choices=STATUSES, default=STATUS_CREATED, verbose_name='Статус')

    message = models.ForeignKey('MailingMessage', on_delete=models.CASCADE, verbose_name='Сообщение', **NULLABLE)

    def __str__(self):
        return f'{self.time} / {self.period}'

    class Meta:
        verbose_name = 'Настройка'
        verbose_name_plural = 'Настройки'


class MailingClient(models.Model):
    client = models.ForeignKey(Client, on_delete=models.CASCADE, verbose_name='Клиент')
    settings = models.ForeignKey(MailingSettings, on_delete=models.CASCADE, verbose_name='Настройка')

    def __str__(self):
        return f'{self.client} / {self.settings}'

    class Meta:
        verbose_name = 'Клиент рассылки'
        verbose_name_plural = 'Клиенты рассылки'


class MailingMessage(models.Model):
    subject = models.CharField(max_length=250, verbose_name='Тема')
    message = models.TextField(verbose_name='Тело')

    def __str__(self):
        return f'{self.subject}'

    class Meta:
        verbose_name = 'Письмо'
        verbose_name_plural = 'Письма'


class MailingLog(models.Model):
    STATUS_OK = 'ok'
    STATUS_FAILED = 'failed'
    STATUSES = (
        (STATUS_OK, 'Успешно'),
        (STATUS_FAILED, 'Ошибка'),
    )

    client = models.ForeignKey(Client, on_delete=models.CASCADE, verbose_name='Клиент')
    settings = models.ForeignKey(MailingSettings, on_delete=models.CASCADE, verbose_name='Настройка')

    status = models.CharField(choices=STATUSES, default=STATUS_OK, verbose_name='Статус')

    last_try = models.DateTimeField(auto_now_add=True, verbose_name='Дата последней попытки')

    class Meta:
        verbose_name = 'Лог'
        verbose_name_plural = 'Логи'

users/models.py
from django.contrib.auth.models import AbstractUser
from django.db import models


class User(AbstractUser):
    pass

mailing/forms.py
from django import forms

from mailing.models import MailingSettings, Client, MailingMessage


class MailingSettingsForm(forms.ModelForm):

    class Meta:
        model = MailingSettings
        fields = '__all__'


class ClientForm(forms.ModelForm):

    class Meta:
        model = Client
        fields = '__all__'


class MessageForm(forms.ModelForm):

    class Meta:
        model = MailingMessage
        fields = '__all__'

mailing/views.py
from django.shortcuts import redirect
from django.urls import reverse_lazy, reverse
from django.views.generic import ListView, CreateView, UpdateView, DeleteView

from mailing.forms import MailingSettingsForm, ClientForm, MessageForm
from mailing.models import MailingSettings, Client, MailingClient, MailingMessage


class MailingListView(ListView):
    model = MailingSettings
    extra_context = {
        'title': 'Список рассылок'
    }


class MailingSettingsCreateView(CreateView):
    model = MailingSettings
    form_class = MailingSettingsForm
    success_url = reverse_lazy('mailing:mailing_list')


class MailingSettingsUpdateView(UpdateView):
    model = MailingSettings
    form_class = MailingSettingsForm
    success_url = reverse_lazy('mailing:mailing_list')


class MailingSettingsDeleteView(DeleteView):
    model = MailingSettings
    success_url = reverse_lazy('mailing:mailing_list')


class MailingClientsListView(ListView):
    model = MailingClient

    def get_context_data(self, *args, **kwargs):
        context_data = super().get_context_data(*args, **kwargs)
        context_data['clients'] = Client.objects.all()
        context_data['mailing_pk'] = self.kwargs.get('pk')
        return context_data


def toggle_client(request, pk, client_pk):
    if MailingClient.objects.filter(client_id=client_pk, settings_id=pk).exists():
        MailingClient.objects.filter(client_id=client_pk, settings_id=pk).delete()
    else:
        MailingClient.objects.create(client_id=client_pk, settings_id=pk)
    return redirect(reverse('mailing:mailing_clients', args=[pk]))


class ClientListView(ListView):
    model = Client
    extra_context = {
        'title': 'Список клиентов'
    }


class ClientCreateView(CreateView):
    model = Client
    form_class = ClientForm
    success_url = reverse_lazy('mailing:clients')


class ClientUpdateView(UpdateView):
    model = Client
    form_class = ClientForm
    success_url = reverse_lazy('mailing:clients')


class ClientDeleteView(DeleteView):
    model = Client
    success_url = reverse_lazy('mailing:clients')


class MessageListView(ListView):
    model = MailingMessage
    extra_context = {
        'title': 'Список сообщений'
    }


class MessageCreateView(CreateView):
    model = MailingMessage
    form_class = MessageForm
    success_url = reverse_lazy('mailing:messages')


class MessageUpdateView(UpdateView):
    model = MailingMessage
    form_class = MessageForm
    success_url = reverse_lazy('mailing:messages')


class MessageDeleteView(DeleteView):
    model = MailingMessage
    success_url = reverse_lazy('mailing:messages')

users/views.py
from django.shortcuts import render

# Create your views here.

mailing/templates/mailing/base.html
{% load static %}
<!doctype html>
<html lang="en" data-bs-theme="auto">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author" content="Mark Otto, Jacob Thornton, and Bootstrap contributors">
    <meta name="generator" content="Hugo 0.112.5">
    <title>Dashboard Template · Bootstrap v5.3</title>

    <link rel="canonical" href="https://getbootstrap.com/docs/5.3/examples/dashboard/">


    <link href="{% static 'css/bootstrap.min.css' %}" rel="stylesheet"
          integrity="sha384-9ndCyUaIbzAi2FUVXJi0CjmCapSmO7SnpJef0486qhLnuZ2cdeRhO02iuK6FUUVM" crossorigin="anonymous">

    <style>
        .bd-placeholder-img {
            font-size: 1.125rem;
            text-anchor: middle;
            -webkit-user-select: none;
            -moz-user-select: none;
            user-select: none;
        }

        @media (min-width: 768px) {
            .bd-placeholder-img-lg {
                font-size: 3.5rem;
            }
        }

        .b-example-divider {
            width: 100%;
            height: 3rem;
            background-color: rgba(0, 0, 0, .1);
            border: solid rgba(0, 0, 0, .15);
            border-width: 1px 0;
            box-shadow: inset 0 .5em 1.5em rgba(0, 0, 0, .1), inset 0 .125em .5em rgba(0, 0, 0, .15);
        }

        .b-example-vr {
            flex-shrink: 0;
            width: 1.5rem;
            height: 100vh;
        }

        .bi {
            vertical-align: -.125em;
            fill: currentColor;
        }

        .nav-scroller {
            position: relative;
            z-index: 2;
            height: 2.75rem;
            overflow-y: hidden;
        }

        .nav-scroller .nav {
            display: flex;
            flex-wrap: nowrap;
            padding-bottom: 1rem;
            margin-top: -1px;
            overflow-x: auto;
            text-align: center;
            white-space: nowrap;
            -webkit-overflow-scrolling: touch;
        }

        .btn-bd-primary {
            --bd-violet-bg: #712cf9;
            --bd-violet-rgb: 112.520718, 44.062154, 249.437846;

            --bs-btn-font-weight: 600;
            --bs-btn-color: var(--bs-white);
            --bs-btn-bg: var(--bd-violet-bg);
            --bs-btn-border-color: var(--bd-violet-bg);
            --bs-btn-hover-color: var(--bs-white);
            --bs-btn-hover-bg: #6528e0;
            --bs-btn-hover-border-color: #6528e0;
            --bs-btn-focus-shadow-rgb: var(--bd-violet-rgb);
            --bs-btn-active-color: var(--bs-btn-hover-color);
            --bs-btn-active-bg: #5a23c8;
            --bs-btn-active-border-color: #5a23c8;
        }

        .bd-mode-toggle {
            z-index: 1500;
        }
    </style>


    <!-- Custom styles for this template -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.10.3/font/bootstrap-icons.css" rel="stylesheet">
    <!-- Custom styles for this template -->
    <link href="{% static 'css/dashboard.css' %}" rel="stylesheet">
</head>
<body>

<header class="navbar sticky-top bg-dark flex-md-nowrap p-0 shadow" data-bs-theme="dark">
    <a class="navbar-brand col-md-3 col-lg-2 me-0 px-3 fs-6 text-white" href="#">SkyChimp</a>
</header>

<div class="container-fluid">
    <div class="row">
        <div class="sidebar border border-right col-md-3 col-lg-2 p-0 bg-body-tertiary">
            <div class="offcanvas-lg offcanvas-end bg-body-tertiary" tabindex="-1" id="sidebarMenu"
                 aria-labelledby="sidebarMenuLabel">
                <div class="offcanvas-header">
                    <h5 class="offcanvas-title" id="sidebarMenuLabel">Company name</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="offcanvas" data-bs-target="#sidebarMenu"
                            aria-label="Close"></button>
                </div>
                <div class="offcanvas-body d-md-flex flex-column p-0 pt-lg-3 overflow-y-auto">
                    <ul class="nav flex-column">
                        <li class="nav-item">
                            <a class="nav-link d-flex align-items-center gap-2 active" aria-current="page" href="{% url 'mailing:mailing_list' %}">
                                Рассылки
                            </a>
                        </li>
                    </ul>
                    <ul class="nav flex-column">
                        <li class="nav-item">
                            <a class="nav-link d-flex align-items-center gap-2 active" aria-current="page" href="{% url 'mailing:clients' %}">
                                Клиенты
                            </a>
                        </li>
                    </ul>
                    <ul class="nav flex-column">
                        <li class="nav-item">
                            <a class="nav-link d-flex align-items-center gap-2 active" aria-current="page" href="{% url 'mailing:messages' %}">
                                Сообщения
                            </a>
                        </li>
                    </ul>

                    <hr class="my-3">

                    <ul class="nav flex-column mb-auto">
                        <li class="nav-item">
                            <a class="nav-link d-flex align-items-center gap-2" href="#">
                                Выйти
                            </a>
                        </li>
                    </ul>
                </div>
            </div>
        </div>

        <main class="col-md-9 ms-sm-auto col-lg-10 px-md-4">
            <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center pt-3 pb-2 mb-3 border-bottom">
                <h1 class="h2">{{ title }}</h1>
            </div>
            {% block content %}
            {% endblock %}
        </main>
    </div>
</div>
<script src="/docs/5.3/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-geWF76RCwLtnZ8qwWowPQNguL3RmwHVBC9FhGdlKrxdiJJigb/j/68SIy3Te4Bkz"
        crossorigin="anonymous"></script>

<script src="https://cdn.jsdelivr.net/npm/chart.js@4.2.1/dist/chart.umd.min.js"
        integrity="sha384-gdQErvCNWvHQZj6XZM0dNsAoY4v+j5P1XDpNkcM3HJG1Yx04ecqIHk7+4VBOCHOG"
        crossorigin="anonymous"></script>
<script src="dashboard.js"></script>
</body>
</html>

mailing/templates/mailing/client_confirm_delete.html
{% extends 'mailing/base.html' %}

{% block content %}
    <div class="row">
        <div class="col-4">
            <div class="card">
                <div class="card-header">
                    Удалить клиента
                </div>
                <div class="card-body">
                    <form method="post">
                        {% csrf_token %}
                        Уверены, что хотите удалить клиента {{ object }}?<br>
                        <hr>
                        <button type="submit" class="btn btn-danger">
                            Уверен
                        </button>
                        <a href="{% url 'mailing:clients' %}" class="btn btn-warning">Отмена</a>
                    </form>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

mailing/templates/mailing/client_form.html
{% extends 'mailing/base.html' %}

{% block content %}
    <div class="row">
        <div class="col-4">
            <div class="card">
                <div class="card-header">
                    {% if object %}
                        Изменить клиента
                    {% else %}
                        Создать клиента
                    {% endif %}
                </div>
                <div class="card-body">
                    <form method="post">
                        {% csrf_token %}
                        {{ form.as_p }}
                        <button type="submit" class="btn btn-primary">
                            {% if object %}
                                Сохранить
                            {% else %}
                                Создать
                            {% endif %}
                        </button>
                    </form>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

mailing/templates/mailing/client_list.html
{% extends 'mailing/base.html' %}

{% block content %}
    <div class="row">
        <div class="col-12">
            <a href="{% url 'mailing:clients_create' %}" class="btn btn-primary float-end">
                Создать клиента
            </a>
        </div>
        <div class="col-12">
            <div class="row">
                {% for item in object_list %}
                    <div class="col-4">
                        <div class="card">
                            <div class="card-header">Клиент #{{ item.pk }}</div>
                            <div class="card-body">
                                <table class="table">
                                    <tr>
                                        <td>Почта</td>
                                        <td>{{ item.email }}</td>
                                    </tr>
                                    <tr>
                                        <td>Имя</td>
                                        <td>{{ item.first_name }}</td>
                                    </tr>
                                    <tr>
                                        <td>Фамилия</td>
                                        <td>{{ item.last_name }}</td>
                                    </tr>
                                </table>
                            </div>
                            <div class="card-footer">
                                <a href="{% url 'mailing:clients_update' item.pk %}" class="btn btn-warning text-white">Изменить</a>
                                <a href="{% url 'mailing:clients_delete' item.pk %}" class="btn btn-danger">Удалить</a>
                            </div>
                        </div>
                    </div>
                {% endfor %}
            </div>
        </div>
    </div>
{% endblock %}

mailing/templates/mailing/mailingclient_list.html
{% extends 'mailing/base.html' %}

{% block content %}
    <div class="row">
        <div class="col-6">
            <div class="card">
                <div class="card-header">Клиенты рассылки</div>
                <div class="card-body">
                    <ul class="list-unstyled">
                        {% for item in object_list %}
                            <li>
                                {{ item }}
                                <a class="float-end btn btn-outline-warning" href="{% url 'mailing:mailing_clients_toggle' mailing_pk item.pk %}">Убрать</a>
                            </li>
                        {% endfor %}
                    </ul>
                </div>
                <div class="card-footer">
                    <a href="{% url 'mailing:mailing_list' %}" class="btn btn-info">Назад</a>
                </div>
            </div>
        </div>
        <div class="col-6">
            <div class="card">
                <div class="card-header">Клиенты для добавления</div>
                <div class="card-body">
                    <ul class="list-unstyled">
                        {% for item in clients %}
                            <li>
                                {{ item }}
                                <a class="float-end btn btn-outline-primary" href="{% url 'mailing:mailing_clients_toggle' mailing_pk item.pk %}">Добавить</a>
                            </li>
                        {% endfor %}
                    </ul>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

mailing/templates/mailing/mailingmessage_confirm_delete.html
{% extends 'mailing/base.html' %}

{% block content %}
    <div class="row">
        <div class="col-4">
            <div class="card">
                <div class="card-header">
                    Удалить сообщение
                </div>
                <div class="card-body">
                    <form method="post">
                        {% csrf_token %}
                        Уверены, что хотите удалить сообщение "{{ object }}"?<br>
                        <hr>
                        <button type="submit" class="btn btn-danger">
                            Уверен
                        </button>
                        <a href="{% url 'mailing:messages' %}" class="btn btn-warning">Отмена</a>
                    </form>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

mailing/templates/mailing/mailingmessage_form.html
{% extends 'mailing/base.html' %}

{% block content %}
    <div class="row">
        <div class="col-4">
            <div class="card">
                <div class="card-header">
                    {% if object %}
                        Изменить сообщение
                    {% else %}
                        Создать сообщение
                    {% endif %}
                </div>
                <div class="card-body">
                    <form method="post">
                        {% csrf_token %}
                        {{ form.as_p }}
                        <button type="submit" class="btn btn-primary">
                            {% if object %}
                                Сохранить
                            {% else %}
                                Создать
                            {% endif %}
                        </button>
                    </form>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

mailing/templates/mailing/mailingmessage_list.html
{% extends 'mailing/base.html' %}

{% block content %}
    <div class="row">
        <div class="col-12">
            <a href="{% url 'mailing:messages_create' %}" class="btn btn-primary float-end">
                Создать сообщение
            </a>
        </div>
        <div class="col-12">
            <div class="row">
                {% for item in object_list %}
                    <div class="col-4">
                        <div class="card">
                            <div class="card-header">Сообщение #{{ item.pk }}</div>
                            <div class="card-body">
                                <table class="table">
                                    <tr>
                                        <td>Тема</td>
                                        <td>{{ item.subject }}</td>
                                    </tr>
                                </table>
                            </div>
                            <div class="card-footer">
                                <a href="{% url 'mailing:messages_update' item.pk %}" class="btn btn-warning text-white">Изменить</a>
                                <a href="{% url 'mailing:messages_delete' item.pk %}" class="btn btn-danger">Удалить</a>
                            </div>
                        </div>
                    </div>
                {% endfor %}
            </div>
        </div>
    </div>
{% endblock %}

mailing/templates/mailing/mailingsettings_confirm_delete.html
{% extends 'mailing/base.html' %}

{% block content %}
    <div class="row">
        <div class="col-4">
            <div class="card">
                <div class="card-header">
                    Удалить рассылку
                </div>
                <div class="card-body">
                    <form method="post">
                        {% csrf_token %}
                        Уверены, что хотите удалить рассылку "{{ object }}"?<br>
                        <hr>
                        <button type="submit" class="btn btn-danger">
                            Уверен
                        </button>
                        <a href="{% url 'mailing:mailing_list' %}" class="btn btn-warning">Отмена</a>
                    </form>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

mailing/templates/mailing/mailingsettings_form.html
{% extends 'mailing/base.html' %}

{% block content %}
    <div class="row">
        <div class="col-4">
            <div class="card">
                <div class="card-header">
                    {% if object %}
                        Изменить рассылку
                    {% else %}
                        Создать рассылку
                    {% endif %}
                </div>
                <div class="card-body">
                    <form method="post">
                        {% csrf_token %}
                        {{ form.as_p }}
                        <button type="submit" class="btn btn-primary">
                            {% if object %}
                                Сохранить
                            {% else %}
                                Создать
                            {% endif %}
                        </button>
                    </form>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

mailing/templates/mailing/mailingsettings_list.html
{% extends 'mailing/base.html' %}

{% block content %}
    <div class="row">
        <div class="col-12">
            <a href="{% url 'mailing:mailing_create' %}" class="btn btn-primary float-end">
                Создать рассылку
            </a>
        </div>
        <div class="col-12">
            <div class="row">
                {% for item in object_list %}
                    <div class="col-4">
                        <div class="card">
                            <div class="card-header">Рассылка #{{ item.pk }}</div>
                            <div class="card-body">
                                <table class="table">
                                    <tr>
                                        <td>Время</td>
                                        <td>{{ item.time|date:"H:i" }}</td>
                                    </tr>
                                    <tr>
                                        <td>Период</td>
                                        <td>{{ item.get_period_display }}</td>
                                    </tr>
                                    <tr>
                                        <td>Статус</td>
                                        <td>{{ item.get_status_display }}</td>
                                    </tr>
                                    <tr>
                                        <td>Сообщение</td>
                                        <td>{{ item.message }}</td>
                                    </tr>
                                </table>
                            </div>
                            <div class="card-footer">
                                <a href="{% url 'mailing:mailing_update' item.pk %}" class="btn btn-warning text-white">Изменить</a>
                                <a href="{% url 'mailing:mailing_clients' item.pk %}" class="btn btn-info text-white">Клиенты</a>
                                <a href="{% url 'mailing:mailing_delete' item.pk %}" class="btn btn-danger">Удалить</a>
                            </div>
                        </div>
                    </div>
                {% endfor %}
            </div>
        </div>
    </div>
{% endblock %}